#include "abstraction.hpp"

using namespace std ;


abstraction::abstraction()
{
	this->k_dense = 0 ;
	this->degree = 0.0;
	this->degree_in = 0.0;
	this->degree_out = 0.0 ;
	this->degre_simple = 0.0 ;
	this->connected_components = 0 ;
	this->triangles = false ;
	this->classic_hub_autority = make_pair(0.0,0.0) ;
	this->hub_autority = make_pair(0.0,0.0) ;
	this->near_star    = make_pair(0.0,0.0) ;
	this->near_star_in = make_pair(0.0,0.0) ;
	this->near_star_out = make_pair(0.0,0.0) ;
	this->abstraction_topologique = 0 ;
	this->role = false ;
}

							// CONSTRUCTEURS

abstraction::abstraction(int k_dense, float degree, float degree_in, float degree_out,
		               	 float degre_simple, int connected_components,
						 bool triangles, pair<float, float> classic_hub_autority,
						 pair<float, float> hub_autority, pair<float, float> near_star,
						 pair<float, float> near_star_in, pair<float, float> near_star_out,
						 float abstraction_topologique, bool role)
{
	this->k_dense = k_dense ;
	this->degree = degree   ;
	this->degree_in = degree_in ;
	this->degree_out = degree_out ;
	this->degre_simple = degre_simple ;
	this->connected_components = connected_components ;
	this->triangles = triangles ;
	this->classic_hub_autority = classic_hub_autority ;
	this->hub_autority = hub_autority ;
	this->near_star = near_star ;
	this->near_star_in = near_star_in ;
	this->near_star_out = near_star_out ;
	this->abstraction_topologique = abstraction_topologique ;
	this->role = role ;
}

							// GETTERS

int abstraction::get_k_dense()
{
	return this-> k_dense ;
}

float abstraction::get_degree()
{
	return this->degree ;
}


float abstraction::get_degree_in()
{
	return this->degree_in ;
}


float abstraction::get_degree_out()
{
	return this->degree_out ;
}

float abstraction::get_degre_simple()
{
	return this->degre_simple ;
}


int abstraction::get_connected_components()
{
	return this->connected_components ;
}

bool abstraction::get_triangles()
{
	return this->triangles ;
}

pair<float, float> abstraction::get_classic_hub_autority()
{
	return this->classic_hub_autority ;
}

pair<float, float> abstraction::get_hub_autority()
{
	return this->hub_autority ;
}

pair<float, float> abstraction::get_near_star()
{
	return this->near_star ;
}

pair<float, float> abstraction::get_near_star_in()
{
	return this->near_star_in ;
}

pair<float, float> abstraction::get_near_star_out()
{
	return this->near_star_out ;
}

float abstraction::get_abstraction_topologique()
{
	return this->abstraction_topologique ;
}

bool abstraction::get_role()
{
	return this->role ;
}

							// SETTERS

void abstraction::set_k_dense(int v)
{
	this->k_dense = v ;
}

void abstraction::set_degree(float v)
{
	this->degree = v ;
}

void abstraction::set_degree_in(float v)
{
	this->degree_in = v ;
}

void abstraction::set_degree_out(float v)
{
	this->degree_out = v ;
}

void abstraction::set_degre_simple(float v)
{
	this->degre_simple = v ;
}

void abstraction::set_connected_components(int v)
{
	this->connected_components = v ;
}

void abstraction::set_triangles(bool v)
{
	this->triangles = v ;
}

void abstraction::set_classic_hub_autority_first(float v)
{
	this->classic_hub_autority.first = v ;
}

void abstraction::set_classic_hub_autority_second(float v)
{
	this->classic_hub_autority.second = v ;
}

void abstraction::set_hub_autority_first(float v)
{
	this->hub_autority.first = v ;
}

void abstraction::set_hub_autority_second(float v)
{
	this->hub_autority.second = v ;
}

void abstraction::set_near_star_first(float v)
{
	this->near_star.first = v ;
}

void abstraction::set_near_star_second(float v)
{
	this->near_star.second = v ;
}

void abstraction::set_near_star_in_first(float v)
{
	this->near_star_in.first = v ;
}

void abstraction::set_near_star_in_second(float v)
{
	this->near_star_in.second = v ;
}

void abstraction::set_near_star_out_first(float v)
{
	this->near_star_out.first = v ;
}

void abstraction::set_near_star_out_second(float v)
{
	this->near_star_out.second = v ;
}

void abstraction::set_abstraction_topologique(float v)
{
	this->abstraction_topologique = v ;
}

void abstraction::set_role(bool role)
{
	this->role = role ;
}

