/*
 * statsModularity.hpp
 *
 *  Created on: 1 juin 2018
 *      Author: bouthinon
 */

#ifndef STATSMODULARITY_HPP_
#define STATSMODULARITY_HPP_

class statsModularity
{
	private :

		int nbLm  = 0 ;
		int nbLme = 0 ;
		int nec   = 0 ;
		int f     = 0 ;

	public:

		statsModularity();
		virtual ~statsModularity();

		int getNec();
		int getNbLm()   ;
		int getNbLme()  ;
		int getF()      ;

		void incNec()   ;
		void incNbLm()  ;
		void incNbLme() ;
		void incF()     ;

		void decNec()   ;
		void decNbLm()  ;
		void decNbLme() ;
		void decF()     ;

		void setNec(int nec) ;
		void setF(int f)     ;
};

#endif /* STATSMODULARITY_HPP_ */
